/**

  The Initial Developer of the Original Code is
  Matthieu  - http://www.actionscript-facile.com
  Portions created by the Initial Developer are Copyright (C) 2010
  the Initial Developer. All Rights Reserved.

  Contributor(s) :

 */
package cours
{

	import com.demonsters.debugger.MonsterDebugger;
	import starling.events.TouchPhase;
	import starling.display.DisplayObject;
	import flash.geom.Point;
	import starling.events.Touch;
	import starling.events.TouchEvent;
	import starling.display.Sprite;
	import starling.events.Event;
	
	

	public class CustomGame extends Sprite
	{
		private var customSprite : CustomSprite;
		
		private var mouseX:Number = 0; 
		private var mouseY:Number = 0; 

		public function CustomGame()
		{
			addEventListener(Event.ADDED_TO_STAGE, onAdded);
		}

		private function onAdded(e : Event) : void
		{
			// création du sprite personnalisé
			customSprite = new CustomSprite(200, 200);

			// centre le sprite sur la scène
			customSprite.x = (stage.stageWidth - customSprite.width >> 1 ) + (customSprite.width >> 1);
			customSprite.y = (stage.stageHeight - customSprite.height >> 1) + (customSprite.height >> 1);

			// l'affichage
			addChild(customSprite);
			
			// écouteur des mouvements de la souris sur la scène
			stage.addEventListener(TouchEvent.TOUCH, onTouch); 
			stage.addEventListener(Event.ENTER_FRAME, onEnterFrame);
			
			// écouteur lorsque le sprite est cliqué
       		customSprite.addEventListener(TouchEvent.TOUCH, onTouchedSprite); 
		}
		
		/**
		 * Appel à chaque image par seconde.
		 * 
		 */
		private function onEnterFrame(e : Event) : void
		{
			// mise à jour de la position du sprite personnalisé 
			customSprite.x -= ( customSprite.x - mouseX ) * .1; 
			customSprite.y -= ( customSprite.y - mouseY ) * .1; 
			
			// mlise à jour du sprite lui même
			customSprite.update();
		}
		
		/**
		 * Appel à chaque mouvement de la souris.
		 * 
		 */
		private function onTouch(e : TouchEvent) : void
		{
			// récupère la position de la souris par rapport à la scène
			var touch : Touch = e.getTouch(stage);
			var pos : Point = touch.getLocation(stage);
			
			// sauvegarde des coordonnées de la sourie
			mouseX = pos.x;
			mouseY = pos.y;
		}
		
		
		/**
		 * Appel lorsque le sprite est cliqué.
		 * 
		 */
		private function onTouchedSprite(e : TouchEvent) : void
		{
			// récupère la position du clique (de la souris) par rapport à la scène
			var touch : Touch = e.getTouch(stage);
			var clicked : DisplayObject = e.currentTarget as DisplayObject;

			// pour vérifier la phase de clique ou de retrait du doigt de l'écran
			if ( touch.phase == TouchPhase.ENDED ) 
			{ 
				// supprime l'objet cliqué ainsi que ses écouteurs. 
				//removeChild(clicked); 
				//clicked.dispose(); // (les écouteurs) pour supprimer les ressources mémoires (garbage collector)
					
				MonsterDebugger.trace(this, "L'objet cliqué envoie-t-il toujours des écouteurs ?");
				MonsterDebugger.trace(this, clicked.hasEventListener(e.type) );
			} 

			// récupère les positions des cliques (des 2 doigts) par rapport à la scène
			var touches : Vector.<Touch> = e.touches;

			// si il y a 2 doigts
			if ( touches.length == 2 )
			{
				var finger1 : Touch = touches[0];
				var finger2 : Touch = touches[1];

				var distance : int;
				var dx : int;
				var dy : int;

				// si les deux doigts sont en mouvement (le glisser - déplacer )
				if ( finger1.phase == TouchPhase.MOVED && finger2.phase == TouchPhase.MOVED )
				{
					// calcul de la distance entre les 2 axes
					dx = Math.abs(finger1.globalX - finger2.globalX);
					dy = Math.abs(finger1.globalY - finger2.globalY);

					// calcul de la distance
					distance = Math.sqrt(dx * dx + dy * dy);

					MonsterDebugger.trace(this, "distance entre les 2 doigts : "+distance);
				}
			}
		}
	}
}