/**

  The Initial Developer of the Original Code is
  Matthieu  - http://www.actionscript-facile.com
  Portions created by the Initial Developer are Copyright (C) 2010
  the Initial Developer. All Rights Reserved.

  Contributor(s) :

 */
package cours
{

	import starling.display.Quad;
	import starling.display.Sprite;
	import starling.events.Event;
	import starling.text.TextField;

	public class CustomSprite extends Sprite
	{
		private var oSquare : Quad;
		
		private var oLegend : TextField;
		
		private var oSquareWidth : uint;
		private var oSquareHeight : uint;
		
		private var r : Number = 30;
		private var g : Number = 33;
		private var b : Number = 2;
		
		private var rDest : Number;
		private var gDest : Number;
		private var bDest : Number;

		public function CustomSprite(width : Number, height : Number)
		{
			// reset la couleur du composant
			resetColors();

			//définit la largeur et la hauteur du carré
			oSquareWidth = width;
			oSquareHeight = height;

			// attend la fin de l'initialisation de la scène
			addEventListener(Event.ADDED_TO_STAGE, activate);
		}

		private function activate(e : Event) : void
		{
			// création d'un carré d'une taille donnée
			oSquare = new Quad(oSquareWidth, oSquareHeight);

			// ajout d'un texte de légende
			oLegend = new TextField(180, 33, "ActionScript Facile !", "Arial", 20, 0x00C5DF, true);

			// affichage
			addChild(oSquare);
			addChild(oLegend);

			// mise à jour du point de référence, les coordonnées 0,0
			pivotX = width >> 1;
			pivotY = height >> 1;
		}

		private function resetColors() : void
		{
			// couleurs aléatoires
			rDest = Math.random() * 255;
			gDest = Math.random() * 255;
			bDest = Math.random() * 255;
		}

		/** 
		 * Mise à jour de nos composants.
		 *  
		 */
		public function update() : void
		{
			r -= (r - rDest) * .03;
			g -= (g - gDest) * .03;
			b -= (b - bDest) * .03;

			// assemblage des couleurs
			var color : uint = r << 16 | g << 8 | b;
			oSquare.color = color;
			
			//choisis une autre couleur lorsque le dégradé est terminé
			if ( Math.abs(r - rDest) < 1 && Math.abs(g - gDest) < 1 && Math.abs(b - bDest) )
				resetColors();
							
			// rotation de notre élément graphique
			rotation += .02;
		}
	}
}
